var identity = require('./index70.js');
var isFunction = require('./index89.js');
var isObject = require('./index97.js');
var isArray = require('./index80.js');
var matcher = require('./index110.js');
var property = require('./index125.js');
var _optimizeCb = require('./index25.js');

// An internal function to generate callbacks that can be applied to each
// element in a collection, returning the desired result — either `_.identity`,
// an arbitrary callback, a property matcher, or a property accessor.
function baseIteratee(value, context, argCount) {
  if (value == null) return identity;
  if (isFunction(value)) return _optimizeCb(value, context, argCount);
  if (isObject(value) && !isArray(value)) return matcher(value);
  return property(value);
}

module.exports = baseIteratee;
